#pragma once

#include "Status.h"

class Stream;
struct Info;

namespace httpsserver
{
	class HTTPRequest;
	class HTTPResponse;
}

namespace detail
{
	class WebServer
	{
	public:
		typedef void (*InfoReceived)(const Info& info);

	public:
		WebServer();
		~WebServer();

		void begin();

		void setStatus(const Status& status);

		void setInfoReceivedCallback(InfoReceived infoReceived) { infoReceived_ = infoReceived; }

	private:
		static void ServerTask_(void* params);
		static void HandleIndex_(httpsserver::HTTPRequest * request, httpsserver::HTTPResponse * response);
		static void HandleGetStatus_(httpsserver::HTTPRequest * request, httpsserver::HTTPResponse * response);
		static void HandlePostInfo_(httpsserver::HTTPRequest * request, httpsserver::HTTPResponse * response);
		static void HandleLogList_(httpsserver::HTTPRequest * request, httpsserver::HTTPResponse * response);
		static void HandleLog_(httpsserver::HTTPRequest * request, httpsserver::HTTPResponse * response);
		static void HandleDefault_(httpsserver::HTTPRequest * request, httpsserver::HTTPResponse * response);

		static void SendContent_(Stream& stream, httpsserver::HTTPResponse * response);

	private:
		Status status_;
		InfoReceived infoReceived_ = nullptr;
	};
}

extern detail::WebServer WebServer;
